<template>
  <div class="UI-dynamic" :id="'UI-dynamic-'+areasName+componentVO.oid">
    <div v-if="isError" style="color: #F56C6C">这个自定义页面的地址格式不正确。推荐使用UI:type#content?param=xxx这种形式</div>
    <component v-else :is="currentComponent"
               :customOptions="customOptions"
               :inDialog="inDialog"
               :key="areasName+'customCom-'+componentVO.oid"
               :componentVO="componentVO"
               :sourceData="sourceData"
               :areasName="areasName"
               :paramVOS="paramVOS"></component>
  </div>
</template>

<script>

export default {
  name: "dynamic-custom",
  props:{
    componentVO:{
      type:Object,
      default: {}
    },
    inDialog: {
      type: Boolean,
      default: false
    },
    areasName:{
      type:String,
      default:''
    },
    sourceData:{
      //菜单源数据或者弹窗时按钮所属区域的上一区域选中数据
      type:Object,
      default: {}
    },
    paramVOS:{
      type:Object,
      default: {}
    },
    isShow: {
      //所在区域是否已显示，针对tab和collapse
      type: Boolean,
      default: true
    },
  },
  components:{
    'my-dynamic-component': ()=>import('@/views/base/UIContentViewerInDialog')
  },
  data() {
    return {
      customClass:this.componentVO.customClass, //UI:type#content?param=xxx或者 组件name:type#content?param=xxx
      isError:false, //路径解析失败
      currentComponent: 'my-dynamic-component',
      componentPath:'@/views/base/UIContentViewerInDialog' //自定义使用的组件路径
    }
  },
  computed:{
    customOptions() {
      let componentPath='@/views/base/UIContentViewerInDialog';
      if(this.customClass.indexOf(":") <0){
        this.isError=true;
        return ;
      }

      if(this.customClass.split(':')[0]!='UI' && this.customClass.split(':')[0]!='ui'){
        componentPath='@/views/custom/'+this.customClass.split(':')[0];
      }
      let urlParams={};
      let btmType=''
      let content=''
      if(this.customClass.split(':')[1].indexOf("?") <0){
        btmType=this.customClass.split(':')[1].split('#')[0];
        content=this.customClass.split(':')[1].split('#')[1];
      }else {
        let split1 = this.customClass.split(':')[1].split('?')[0];
        let split2 = this.customClass.split(':')[1].split('?')[1];
        btmType=split1.split('#')[0];
        content=split1.split('#')[1];
        let paramsArray = split2.split("&");
        paramsArray.forEach(item=>{
          var preParam =item.split("=");
          if(preParam[0]=='btmname'){
            urlParams['btmType']=preParam[1];
          }else if(preParam[0]=='imagetype'){
            urlParams['imageType']=preParam[1];
            if(preParam[1]=='fileobject'){

            }
          }else{
            urlParams[preParam[0]] = preParam[1];
          }
        })
      }

      this.componentPath=componentPath;
      return {
        btmType:btmType,
        content:content,
        urlParams: urlParams,
        uiComponentType: this.componentVO.uiComponentType,
        uiComponentTypeText: this.componentVO.uiComponentTypeText,
        uiParseClass: this.componentVO.uiParseClass
      }
    },
    asyncComponent() {
      return import(this.componentPath);
    }
  },
  created() {
    // debugger;
    // this.components["my-dynamic-component"] = import(this.componentPath);
  }
}
</script>

<style scoped>

</style>
